unit Frame;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Param, ShlObj, ShellAPI;

type
  TFrameForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    FontDialog1: TFontDialog;
    Button1: TButton;
    Parameter1: TParameter;
    Button2: TButton;
    Button3: TButton;
    ListBox1: TListBox;
    Label6: TLabel;
    Button4: TButton;
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure AddSpecial(nFolder: Integer; sFolder: String);
  end;

var
  FrameForm: TFrameForm;

implementation

{$R *.DFM}

procedure TFrameForm.FormShow(Sender: TObject);
begin
  Parameter1.Init; // Parameter1 Ăep[^t@C烍[hB

  Panel1.Caption := Parameter1.ExeName;
  Panel2.Caption := Parameter1.FullName;

  if Parameter1.Count > 0 then // p[^̃[hɐꍇ
  begin
    Left := Parameter1['Left']; // Integer ^̃f[^𓾂B
    Top := Parameter1['Top']; // Integer ^̃f[^𓾂B
    Width := Parameter1['Width']; // Integer ^̃f[^𓾂B
    Height := Parameter1['Height']; // Integer ^̃f[^𓾂B
    WindowState := TWindowState(Parameter1['WindowState']); // Integer ^̃f[^𓾂B
    Edit1.Text := Parameter1.VStrings['Kȕ']; // String ^̃f[^𓾂B
    Edit1.Font.Name := Parameter1.VStrings['FontName']; // String ^̃f[^𓾂B
    Edit1.Font.Size := Parameter1['FontSize']; // Integer ^̃f[^𓾂B
    Edit1.Font.Style := Parameter1.VFontStyles['FontStyle']; // TFontStyles ^̃f[^𓾂B
    Edit1.Font.Color := Parameter1['FontColor']; // Integer ^̃f[^𓾂B
  end
  else // p[^[hoȂꍇ
  begin
    Parameter1.Add('Test.exe ݒt@C --- ̃t@ĆAҏWȂŉB');
    Parameter1['Left'] := Left; //  Parameter1.VIntegers['Left'] := Left; Ƃ̂ƓɂȂ܂B
    Parameter1['Top'] := Top;
    Parameter1['Width'] := Width;
    Parameter1['Height'] := Height;
    Parameter1['WindowState'] := Integer(WindowState);
    Parameter1.VStrings['Kȕ'] := Edit1.Text;
    Parameter1.VStrings['FontName'] := Edit1.Font.Name;
    Parameter1['FontSize'] := Edit1.Font.Size;
    Parameter1.VFontStyles['FontStyle'] := Edit1.Font.Style;
    Parameter1['FontColor'] := Edit1.Font.Color;
  end;

  ListBox1.Font := Edit1.Font;
  ListBox1.Items.BeginUpdate;
  ListBox1.Items.Clear;

  //bZ[W\
  ListBox1.Items.Add(FormatDateTime('yyyy/mm/dd hh:nn:ss', Now));
  ListBox1.Items.Add('');

  AddSpecial(CSIDL_DESKTOP, 'CSIDL_DESKTOP');
  AddSpecial(CSIDL_INTERNET, 'CSIDL_INTERNET');
  AddSpecial(CSIDL_PROGRAMS, 'CSIDL_PROGRAMS');
  AddSpecial(CSIDL_CONTROLS, 'CSIDL_CONTROLS');
  AddSpecial(CSIDL_PRINTERS, 'CSIDL_PRINTERS');
  AddSpecial(CSIDL_PERSONAL, 'CSIDL_PERSONAL');
  AddSpecial(CSIDL_FAVORITES, 'CSIDL_FAVORITES');
  AddSpecial(CSIDL_STARTUP, 'CSIDL_STARTUP');
  AddSpecial(CSIDL_RECENT, 'CSIDL_RECENT');
  AddSpecial(CSIDL_SENDTO, 'CSIDL_SENDTO');
  AddSpecial(CSIDL_BITBUCKET, 'CSIDL_BITBUCKET');
  AddSpecial(CSIDL_STARTMENU, 'CSIDL_STARTMENU');
  AddSpecial(CSIDL_DESKTOPDIRECTORY, 'CSIDL_DESKTOPDIRECTORY');
  AddSpecial(CSIDL_DRIVES, 'CSIDL_DRIVES');
  AddSpecial(CSIDL_NETWORK, 'CSIDL_NETWORK');
  AddSpecial(CSIDL_NETHOOD, 'CSIDL_NETHOOD');
  AddSpecial(CSIDL_FONTS, 'CSIDL_FONTS');
  AddSpecial(CSIDL_TEMPLATES, 'CSIDL_TEMPLATES');
  AddSpecial(CSIDL_COMMON_STARTMENU, 'CSIDL_COMMON_STARTMENU');
  AddSpecial(CSIDL_COMMON_PROGRAMS, 'CSIDL_COMMON_PROGRAMS');
  AddSpecial(CSIDL_COMMON_STARTUP, 'CSIDL_COMMON_STARTUP');
  AddSpecial(CSIDL_COMMON_DESKTOPDIRECTORY, 'CSIDL_COMMON_DESKTOPDIRECTORY');
  AddSpecial(CSIDL_APPDATA, 'CSIDL_APPDATA');
  AddSpecial(CSIDL_PRINTHOOD, 'CSIDL_PRINTHOOD');
  AddSpecial(CSIDL_ALTSTARTUP, 'CSIDL_ALTSTARTUP');
  AddSpecial(CSIDL_COMMON_ALTSTARTUP, 'CSIDL_COMMON_ALTSTARTUP');
  AddSpecial(CSIDL_COMMON_FAVORITES, 'CSIDL_COMMON_FAVORITES');
  AddSpecial(CSIDL_INTERNET_CACHE, 'CSIDL_INTERNET_CACHE');
  AddSpecial(CSIDL_COOKIES, 'CSIDL_COOKIES');
  AddSpecial(CSIDL_HISTORY, 'CSIDL_HISTORY');

  ListBox1.Items.EndUpdate;
end;

procedure TFrameForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if WindowState <> wsMaximized then
  begin
    Parameter1['Left'] := Left;
    Parameter1['Top'] := Top;
    Parameter1['Width'] := Width;
    Parameter1['Height'] := Height;
  end;
  Parameter1['WindowState'] := Integer(WindowState);
  Parameter1.VStrings['Kȕ'] := Edit1.Text;
  Parameter1.VStrings['FontName'] := Edit1.Font.Name;
  Parameter1['FontSize'] := Edit1.Font.Size;
  Parameter1.VFontStyles['FontStyle'] := Edit1.Font.Style;
  Parameter1['FontColor'] := Edit1.Font.Color;
  Parameter1.SaveToFile;
end;

procedure TFrameForm.Button1Click(Sender: TObject);
begin
  FontDialog1.Font := Edit1.Font;
  if FontDialog1.Execute then
  begin
    Edit1.Font := FontDialog1.Font;
    ListBox1.Font := FontDialog1.Font;
  end;
end;

procedure TFrameForm.Button2Click(Sender: TObject);
begin
  Parameter1.CreateShortCut(CSIDL_DESKTOP, 'TParameter ̃eXg');
end;

procedure TFrameForm.Button3Click(Sender: TObject);
begin
  Parameter1.DeleteShortCut(CSIDL_DESKTOP, 'TParameter ̃eXg');
end;

procedure TFrameForm.AddSpecial(nFolder: Integer; sFolder: String);
var
  S: String;
begin
  S := GetSpecialFolder(nFolder);
  if S <> '' then
  begin
    if sFolder = '' then
      S := IntToStr(nFolder) + ' : ' + S
    else
      S := IntToHex(nFolder, 2) + 'H = ' + sFolder + ' : ' + S;
    ListBox1.Items.Add(S);
  end;
end;

procedure TFrameForm.Button4Click(Sender: TObject);
begin
  if FileExists(Parameter1.FullName) then
    ShellExecute(Handle, PChar('open'), PChar(Parameter1.FullName),
                 Nil, Nil, SW_SHOW);
end;

end.
